/*
 * Fachlicher Schlüssel für JPA Entität
 */
package de.ivu.elect.business.stimmeingabe.entity;

import de.ivu.elect.jee.faces.Messages;
import de.ivu.elect.jee.faces.IMessages;
import java.util.function.Function;

@javax.enterprise.inject.Vetoed
public class ZwischensummeEingabeTK
extends de.ivu.elect.business.stimmeingabe.entity.StimmeingabeTK
  {

  private static final long serialVersionUID = 1L;

  private final int hashCode;

    protected final java.lang.Long summenIndex;
    public java.lang.Long getSummenIndex(){
      return summenIndex;
    }

  public ZwischensummeEingabeTK(
de.ivu.elect.business.ergebnis.entity.Stimmenart stimmenart
,   de.ivu.elect.business.gruppeimgebiet.entity.GruppeImGebietTK gruppeImGebietTK
,   de.ivu.elect.business.kandidatur.entity.ListenkandidaturTK listenkandidaturTK
,   de.ivu.elect.business.wahlvorschlag.entity.ReferendumOptionTK referendumOptionTK
, java.lang.Long summenIndex
  ) {
super(

stimmenart

,   gruppeImGebietTK
,   listenkandidaturTK
,   referendumOptionTK
);


      this.summenIndex = summenIndex;
    
hashCode = calculateHashCode();
  }

  @Override
  public int hashCode(){
    return hashCode;
  }


  protected int calculateHashCode() {
        int result = super.calculateHashCode();
    
    
                    result = result + ((summenIndex == null) ? 0 : summenIndex.hashCode());
        
            
    return result;
  }

  @Override
  public boolean equals(Object obj) {
    if (this == obj) {
      return true;
    }

    if (obj == null) {
      return false;
    }

    if (hashCode()!=obj.hashCode()) {
      return false;
    }


                    if (super.hatAttribute() && !super.equals(obj)) {
          return false;
        }
        
    if (getClass() != obj.getClass()) {
      if (!(obj instanceof ZwischensummeEingabeTK)) {
        return false;
      }

      if (!obj.getClass().isInstance(this)) {
        return obj.equals(this); // equals-Methode aus speziellerer Klasse verwenden
      }

    }

        ZwischensummeEingabeTK other = (ZwischensummeEingabeTK) obj;

                if (summenIndex == null) {
          if (other.summenIndex != null) {
            return false;
          }
        } else if (!summenIndex.equals(other.summenIndex)) {
          return false;
        }
        
            return true;
    
  }

  protected boolean hatAttribute() {
        return true;
      }

  @Override
  public String getEntityMessageKey() {
    return ZwischensummeEingabeConstants.MESSAGE_KEY_ENTITY_EINZAHL;
  }

  @Override
  public java.util.List<de.ivu.elect.jee.entity.tk.EntityFieldValue> getAllEntityFieldValues() {
    java.util.List<de.ivu.elect.jee.entity.tk.EntityFieldValue> result = new java.util.ArrayList<>();

    result.addAll(super.getAllEntityFieldValues());
    result.addAll(getEntityFieldValuesForEntity());
    return result;
  }

  @Override
  public java.util.List<de.ivu.elect.jee.entity.tk.EntityFieldValue> getEntityFieldValuesForEntity() {
            java.util.List<de.ivu.elect.jee.entity.tk.EntityFieldValue> result = new java.util.ArrayList<>();

                    result.add(new de.ivu.elect.jee.entity.tk.EntityFieldValue(ZwischensummeEingabeConstants.MESSAGE_KEY_ENTITY_EINZAHL, ZwischensummeEingabeConstants.MESSAGE_KEY_SUMMEN_INDEX_EINZAHL, summenIndex));
        
        return result;
      }


            @Override
            public String toString() {
            return "ZwischensummeEingabeTK[" + toStringParameter() + "]";
            }



            protected String toStringParameter() {
            String result = ""

                                        +"summenIndex="+summenIndex
                        
            ;
                            String resultParent = super.toStringParameter();
                if (resultParent.isEmpty()) {
                return result;
                }
                if (result.isEmpty()) {
                return resultParent;
                }
                return resultParent +", " + result;
            
            }


      @Override       protected String toStringLokalisiertFields(IMessages messages) {
        return ""
                                      + messages.getMessageForMessageKey(ZwischensummeEingabeConstants.MESSAGE_KEY_SUMMEN_INDEX_EINZAHL) + "=" + summenIndex
                                                  + super.toStringLokalisiertFields(messages)
                     ;
      }


            private String toStringLokalisiert(de.ivu.elect.jee.entity.tk.EntityTK entityTK, IMessages messages) {
                if (entityTK != null) {
                    return entityTK.toStringLokalisiert(messages);
                }
                return null;
            }

            public static <E extends ZwischensummeEingabe> java.util.Map<ZwischensummeEingabeTK, E> mappeZwischensummeEingabeNachTK(java.util.Collection<E> entities) {
                return entities.stream().collect(java.util.stream.Collectors.toMap(ZwischensummeEingabe::getZwischensummeEingabeTK, Function.<E>identity(), (u,v)-> v));
                }


                public static Function<ZwischensummeEingabe, ZwischensummeEingabeTK> getZwischensummeEingabeToTKFunction() {
                return ZwischensummeEingabe::getZwischensummeEingabeTK;
                }

}
